// scripts/constants/settings.js

// --- General Settings ---
export const VERSION = "v1.15.2";
export const OUTLINE_PARTICLE = "minecraft:balloon_gas_particle";
export const OUTLINE_INTERVAL = 10;
export const PLAYER_SPEED_INTERVAL = 3;
export const MAX_VIEW_DISTANCE = 100;
export const MAX_SELECTION_DISTANCE = 9;

// --- Extended Reach Feature ---
export const DEFAULT_EXTENDED_REACH_ENABLED = false;
export const EXTENDED_REACH_DISTANCE = 100;

// --- Limits ---
export const MAX_UNDO_HISTORY = 30;
export const MAX_COPY_VOLUME = 200000;
export const MAX_HEIGHT_BRUSH_AMOUNT = 16;
export const MAX_BRUSH_VOLUME = 50000;
export const MAX_STACK_COUNT = 20;
export const MAX_STACK_AFFECTED_VOLUME = 500000;
export const MAX_LINE_LENGTH = 50000;
export const MAX_PATH_LENGTH = 50000;
export const BLOCKS_PER_CHUNK = 8192;

// --- Ticking Area Settings ---
export const TICKING_AREA_THRESHOLD_VOLUME = 65536;
export const TICKING_AREA_LOAD_DELAY_TICKS = 40;


// --- Brush/Tool Defaults & Settings ---
export const MAX_BRUSH_SIZE = 32;
export const DEFAULT_BRUSH_SIZE = 7;
export const MAX_EXPAND_CONTRACT = 32;
export const PARTICLE_EDGE_OFFSET = 0.1;
export const DEFAULT_BRUSH_MATERIAL = "minecraft:stone";
export const DEFAULT_PAINT_MASK_BLOCK = "";
export const DEFAULT_HEIGHT_BRUSH_AMOUNT = 1;
export const PREVIEW_PARTICLE_DENSITY = 0.75;
export const MIN_PREVIEW_PARTICLES_PER_EDGE = 4;
// Foliage Brush Defaults
export const DEFAULT_FOLIAGE_RADIUS = 5;
export const DEFAULT_FOLIAGE_DENSITY = 25;
export const DEFAULT_FOLIAGE_SOURCE = 'preset';
export const DEFAULT_FOLIAGE_PRESET = 'Forest';
export const DEFAULT_FOLIAGE_CUSTOM = 'minecraft:short_grass,minecraft:poppy';
export const MAX_FOLIAGE_RADIUS = 32;
// Path Tool Defaults
export const DEFAULT_PATH_MATERIAL = "minecraft:stone";
export const DEFAULT_PATH_CURVE_TYPE = "Linear";
export const DEFAULT_PATH_SMOOTHNESS = 4;
export const DEFAULT_PATH_WIDTH = 1;
export const MAX_PATH_WIDTH = 21;
// Terrain Generation Defaults
export const DEFAULT_TERRAIN_BASE_MATERIAL = "minecraft:stone";
export const DEFAULT_TERRAIN_SURFACE_MATERIAL = "minecraft:grass_block";
export const DEFAULT_TERRAIN_SURFACE_DEPTH = 3;
export const DEFAULT_TERRAIN_NOISE_TYPE = "Simplex";
export const DEFAULT_TERRAIN_FREQUENCY = 0.05;
export const DEFAULT_TERRAIN_AMPLITUDE = 10;
export const DEFAULT_TERRAIN_SEED_TYPE = "Random";
export const DEFAULT_TERRAIN_OCTAVES = 4;
export const DEFAULT_TERRAIN_LACUNARITY = 2.0;
export const DEFAULT_TERRAIN_PERSISTENCE = 0.5;
export const DEFAULT_TERRAIN_WARP_ENABLED = false;
export const DEFAULT_TERRAIN_WARP_AMPLITUDE = 5.0;
export const DEFAULT_TERRAIN_WARP_FREQUENCY = 0.1;
export const DEFAULT_TERRAIN_JITTER = 0.8;

// --- Player Settings Defaults ---
export const DEFAULT_PLAYER_SPEED_MULTIPLIER = 1.0;
export const MIN_PLAYER_SPEED_MULTIPLIER = 0.5;
export const MAX_PLAYER_SPEED_MULTIPLIER = 50.0;
export const DEFAULT_PLAYER_VERTICAL_SPEED_MULTIPLIER = 1.0;
export const MIN_PLAYER_VERTICAL_SPEED_MULTIPLIER = 0.5;
export const MAX_PLAYER_VERTICAL_SPEED_MULTIPLIER = 30.0;
export const DEFAULT_AUTO_SPECTATOR_ENABLED = false;
export const DEFAULT_AUTO_SPECTATOR_DETECTION_DISTANCE = 1.0;
export const DEFAULT_SHOW_ACTION_FEEDBACK_MESSAGES = true;

// --- Structure Manager ---
export const STRUCTURE_NAMESPACE = "we";

// --- Dynamic Property Keys ---
export const PALETTES_PROPERTY_ID = "worldedit:palettes";
export const GLOBAL_SETTINGS_PROPERTY_ID = "bwe:global_settings";
