// scripts/events/index.js

import { setupIntervalListener } from './interval.js';
import { setupItemUseListener } from './item_use.js';
import { setupItemUseBeforeListener } from './item_use_before.js';
import { setupItemUseOnBeforeListener } from './item_use_on_before.js'; // This import should be correct
import { setupPlayerLeaveListener } from './player_leave.js';
import { setupPlayerTickMovementListener } from './player_tick_movement.js';

/**
 * Sets up all event listeners required for the WorldEdit addon.
 * This should be called once when the script starts (e.g., in main.js).
 */
export function setupAllListeners() {
    setupItemUseListener();
    setupItemUseBeforeListener();
    setupItemUseOnBeforeListener(); // Function call
    setupIntervalListener();
    setupPlayerTickMovementListener();
    setupPlayerLeaveListener();
    console.log("[WorldEdit Addon] All event listeners initialized.");
}
